#include <iostream>
#include <vector>
#include <cmath>
#include <math.h>
#include <set>
using namespace std;
const int L = 1 << 3;
vector<int> x(2 * L + 1);

int min(int a, int b) {
	if (a < b) return a;
	return b;
}

int max(int a, int b) {
	if (a > b) return a;
	return b;
}

void insert(int a, int b, int l, int r,int id) {
	if (l == r - 1) x[id] = b;
	else {
		int m = (l + r) / 2;
		if (a < m) insert(a, b, l, m, id * 2);
		else insert(a, b, m, r, id * 2 + 1);
		x[id] = max(x[id * 2], x[id * 2 + 1]);
	}
}

int ask(int a,int b, int l, int r, int id) {
	if (a <= l && b >= r - 1) return x[id];
	if (l > b || r <= a) {
		return 0;
	}
	int m = (l + r) / 2;
	return(max(ask(a, b, l, m, id * 2), ask(a, b, m, r, id * 2 + 1)));
}



int main() {
	int n, m;
	cin >> n >> m;
	vector<int> a(m);
	vector<int> b(n);
	vector<vector<int>> ra(m);
	vector<int> rb(n);
	vector<set<int>> v(n);
	vector<int> kek(n);
	for (int i = 0; i < m; i++) {
		cin >> a[i];
		--a[i];
		ra[a[i]].push_back(i);
		v[a[i]].insert(i);
	}
	for (int i = 0; i < n; i++) ra[i].push_back(1e8);
	for (int i = 0; i < n; i++) {
		cin >> b[i];
		--b[i];
		rb[b[i]] = i;
	}

	for (int i = 0; i < m; i++) {
		int c = a[i];
		int d = rb[c];
		//insert(i + 1, d, 1, L + 1, 1);
	}
	bool flag1 = true;
	if( n != m) flag1 = false;
	else {
		for (int i = 0; i < n; i++) if (a[i] != b[i]) flag1 = false;
	}
	if (flag1) {
		cout << n << endl;
		for (int i = 0; i < n; i++) cout << n << ' ';
	}

	else {
		for (int i = 0; i < m; i++) {
			bool flag = true;
			while (flag) {
				if (a[i] == b[0])
					flag = false;
				int c = b[0];
				if (c == a[i]) {
					kek[a[i]]++;
				}
				int d = ask(i + 2, min(ra[c][kek[c]], L + 2), 1, L + 1, 1);
				cout << d + 1 << ' ';
				for (int j = 1; j <= d; j++) {
					b[j - 1] = b[j];
					kek[b[j - 1]] = kek[b[j]];
					rb[b[j - 1]] = j - 1;
					if (ra[b[j - 1]][kek[b[j - 1]]] != 1e8) {
						insert(ra[b[j - 1]][kek[b[j - 1]]], j - 1, 1, L + 1, 1);
					}
				}
				b[d] = c;
				kek[d] = kek[0];
				rb[b[d]] = c;
				if (ra[b[d]][kek[b[d]]] != 1e8) {
					insert(ra[b[d]][kek[b[d]]], d, 1, L + 1, 1);
				}
			}
		}
	}
	cin >> n;
}
/*
4 5
4 1 2 4 4
4 3 2 1
*/