#include <iostream>
#include <vector>
#include <cmath>
#include <math.h>
#include <set>
using namespace std;
const int L = 1 << 3;
vector<int> x(2 * L + 1);

int min(int a, int b) {
	if (a < b) return a;
	return b;
}

int max(int a, int b) {
	if (a > b) return a;
	return b;
}

void insert(int a, int b, int l, int r,int id) {
	if (l == r - 1) x[id] = b;
	else {
		int m = (l + r) / 2;
		if (a < m) insert(a, b, l, m, id * 2);
		else insert(a, b, m, r, id * 2 + 1);
		x[id] = max(x[id * 2], x[id * 2 + 1]);
	}
}

int ask(int a,int b, int l, int r, int id) {
	if (a <= l && b >= r - 1) return x[id];
	if (l > b || r <= a) {
		return 0;
	}
	int m = (l + r) / 2;
	return(max(ask(a, b, l, m, id * 2), ask(a, b, m, r, id * 2 + 1)));
}

void sosat() {
	while (true) {
		int a;
		a = 1;
	}
}


int main() {
	int n, m;
	cin >> n >> m;
	vector<int> a(m);
	vector<int> b(n);
	vector<vector<int>> ra(m);
	vector<int> rb(n);
	vector<set<int>> v(n);
	vector<int> kek(n);
	for (int i = 0; i < m; i++) {
		cin >> a[i];
		--a[i];
		ra[a[i]].push_back(i);
		v[a[i]].insert(i);
	}
	for (int i = 0; i < n; i++) ra[i].push_back(1e8);
	for (int i = 0; i < n; i++) {
		cin >> b[i];
		--b[i];
		rb[b[i]] = i;
	}

	for (int i = 0; i < m; i++) {
		int c = a[i];
		int d = rb[c];
		//insert(i + 1, d, 1, L + 1, 1);
	}
	bool flag1 = true;
	if( n != m) flag1 = false;
	else {
		for (int i = 0; i < n; i++) if (a[i] != b[i]) flag1 = false;
	}
	if (flag1) {
		cout << n << endl;
		for (int i = 0; i < n; i++) cout << n << ' ';
	}

	else {
		bool flag2 = true;
		if (n != m) flag2 = false;
		else {
			for (int i = 0; i < n; i++) if (a[i] != b[n - i - 1]) flag2 = false;
		}
		if (flag2) {
			cout << 2 * n - 1 << endl;
			for (int i = 0; i < n-1; i++) cout << n-i<<' ';
			for (int i = 0; i < n; i++) cout << n << ' ';
		}
		else {
			vector<int> ans;
			for (int i = 0; i < m; i++) {
				bool flag = true;
				while (flag) {
					if (a[i] == b[0]) {
						flag = false;
						kek[a[i]]++;
					}
					int ma = -1;
					int c = b[0];
					int d = rb[b[0]];
					int e = kek[b[0]];
					for (int j = 0; j < n; j++) {
						if (kek[j] >= ra[j].size()) while (true) {
							sosat();
						}
						if (ra[j][kek[j]] >= i && ra[j][kek[j]] <= ra[b[0]][kek[b[0]]])
							ma = max(ma, rb[j]);
					}
					if (ra[b[0]][kek[b[0]]] == 1e8) ma = n - 1;
					ans.push_back(ma + 1);
					for (int j = 1; j <= ma; j++) {
						if (rb.size() >= b[j] || rb.size() >= b[j - 1]) sosat();
						swap(rb[b[j]], rb[b[j - 1]]);
						swap(b[j], b[j - 1]);
						
					}
					b[ma] = c;
					rb[b[ma]] = ma;
				}
			}
			cout << ans.size() << endl;
			for (int i = 0; i < ans.size(); i++) cout << ans[i] << ' ';
		}
	}
	cin >> n;
}
/*
4 5
4 1 2 4 4
4 3 2 1
*/ 