﻿#include <iostream>
#include <vector>
#include <cmath>
#include <math.h>
#include <set>
using namespace std;
int  mod = 1e9 + 7;
const long int L = 3e5;
vector<vector<int>> g(L);
vector<int> used(L), used1(L);
vector<vector<long long>> dp(L, vector<long long>(4));
vector<int> p(L, -1);
int q = -1;

int min(int a, int b) {
	if (a < b) return a;
	return b;
}

int max(int a, int b) {
	if (a > b) return a;
	return b;
}

void dfs1(int u) {
	used1[u] = 1;
	for (auto v : g[u]) {
		if (used1[v] == 1 && v != p[u]) q = v;
		if (used1[v] == 0) {
			p[v] = u;
			dfs1(v);
		}
	}
	used1[u] = 2;
}


void dfs(int u) {
	used[u] = 1;
	for (auto v : g[u]) {
		if (used[v] == 0) {
			p[v] = u;
			dfs(v);
			if (u != q) {
				dp[u][0] += max(dp[v][0], dp[v][1]);
				dp[u][1] += dp[v][0];
				dp[u][2] += max(dp[v][2], dp[v][3]);
				dp[u][3] += dp[v][2];
			}
			else {
				dp[u][0] += max(dp[v][0], dp[v][1]);
				dp[u][1] = 0;
				dp[u][2] = 0;
				dp[u][3] += dp[v][0];
			}
		}
		if (v == q) {
			dp[u][0] += max(dp[v][0], dp[v][1]);
			dp[u][1] += dp[v][0];
			dp[u][2] += max(dp[v][2], dp[v][3]);
			dp[u][3] += dp[v][2];
		}
	}
	if (u != q) {
		dp[u][1]++;
		if (dp[u][3] != 0)
			dp[u][3]++;
	}
	else {
		dp[u][3] = 1;
	}
	used[u] = 2;
}



int main() {

	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		int a;
		cin >> a;
		--a;
		if (a != -2) {
			g[i].push_back(a);
			g[a].push_back(i);
		}
	}
	long long ans = 0;
	for (int i = 0; i < n; i++) {
		if (used[i] == 0) {
			dfs1(i);
			dfs(i);
			ans += max(dp[i][0], max(dp[i][1], max(dp[i][2], dp[i][3])));
		}
	}
	cout << ans;
	cin >> ans;

}

/*
4
2
4
2
1
*/