#include <iostream>
#include <vector>
#include <cmath>
#include <math.h>
#include <set>
using namespace std;
long long mod = 1e9 + 7;
vector<vector<long long>> binom(20, vector<long long>(20));


int min(int a, int b) {
	if (a < b) return a;
	return b;
}

int max(int a, int b) {
	if (a > b) return a;
	return b;
}

int num(long long q) {
	if (q == 0) return 0;
	return(q % 2 + num(q / 2));
}

int main() {
	
	long long n, m, k;
	cin >> n >> m >> k;
	long long l = (log(k) / log(2)+0.999999);

	vector<long long> p(l + 1);
	p[0] = 1;
	for (int i = 1; i <= l; i++) {
		p[i] = p[i - 1] * n;
		p[i] %= mod;
	}
	long long ans = 0;
	for (int i = 0; i <= k; i++) {
		ans += p[num(i)];
		ans %= mod;
	}
	cout << ans;
	cin >> ans;
}
/*
4 5
4 1 2 4 4
4 3 2 1
*/ 