#include <iostream>
#include <vector>
#include <cmath>
#include <math.h>
#include <set>
using namespace std;
long long mod = 1e9 + 7;
vector<vector<long long>> binom(90, vector<long long>(90));
vector<long long> dp(71);

int min(int a, int b) {
	if (a < b) return a;
	return b;
}

int max(int a, int b) {
	if (a > b) return a;
	return b;
}

int num(long long q) {
	if (q == 0) return 0;
	return(q % 2 + num(q / 2));
}

int main() {
	
	long long n, m, k;
	cin >> n >> m >> k;
	long long l = 70;

	vector<long long> p(71);
	p[0] = 1;
	for (int i = 1; i <= l; i++) {
		p[i] = p[i - 1] * n;
		p[i] %= mod;
	}

	for (int i = 0; i < 70; i++) {
		binom[0][i] = 1;
	}
	for (int i = 1; i < 70; i++) {
		for (int j = i; j < 70; j++) {
			binom[i][j] = binom[i - 1][j - 1] + binom[i][j - 1];
		}
	}

	long long h = k;

	int numm = 0;
	long long q = 1;
	for (int i = 0; i < 60; i++) {
		q *= 2;
	}
	for (int i = 60; i >= 0; --i) {
		if (h / q == 1) {
			for (int j = numm; j < 60; j++) {
				dp[j] += binom[j - numm][i];
				dp[j] %= mod;
			}
			numm++;
		}
		h = h % q;
		q /= 2;
	}
	dp[numm] += 1;


	long long ans = 0;
	for (int i = 0; i < 60; i++) {
		ans += dp[i] * p[i];
		ans %= mod;
	}
	cout << ans;
	cin >> ans;
}
/*
4 5
4 1 2 4 4
4 3 2 1
*/ 