﻿using namespace std;
#include <vector>
#include <cmath>
#include <math.h>
#include <set>
#include <iostream>

int mod = 1e9+7;

int min(int a, int b) {
	if (a < b) return a;
	return b;
}

int max(int a, int b) {
	if (a > b) return a;
	return b;
}

int main() {
	int n, k;
	cin >> n >> k;
	vector<vector<int >> dp1(n + 2, vector<int >(n + 2));
	vector<vector<int >> dp2(n + 2, vector<int >(n + 2));
	vector<vector<int >> dp3(n + 2, vector<int >(n + 2));
	vector<vector<int >> dp4(n + 2, vector<int >(n + 2));
	dp1[k][k] = 1;
	dp2[k][k] = 1;
	for (int i = 1; i < k; i++) dp4[k][i] = 1;
	for (int i = k + 1; i <= n + 1; i++) dp3[k][i] = 1;
	for (int i = k + 1; i <= n; i++) {
		for (int j = i; j >= 1; --j) {
			dp2[i][j] = dp3[i - j][j];
			dp1[i][j] = dp4[i - j][j];
		}
		dp4[i][n + 1] = 0;
		dp3[i][1] = 0;
		for (int j = 2; j <= n + 1; j++) {
			dp3[i][j] = dp3[i][j - 1];
			dp3[i][j] += dp2[i][j - 1];
			dp3[i][j] %= mod;
		}
		for (int j = n; j >= 1; --j) {
			dp4[i][j] = dp4[i][j + 1];
			dp4[i][j] += dp1[i][j + 1];
			dp4[i][j] %= mod;

		}
	}
	int ans = 0;
	for (int i = 0; i <= n; i++) {
		ans += dp1[n][i];
		ans %= mod;
		ans += dp2[n][i];
		ans %= mod;
	}
	if (n == k) ans = 1;
	cout << ans;
	cin >> ans;
}