#include <iostream>
#include <vector>
#include <cmath>
#include <math.h>
#include <set>
using namespace std;
long long mod = 1e9 + 7;

int min(int a, int b) {
	if (a < b) return a;
	return b;
}

int max(int a, int b) {
	if (a > b) return a;
	return b;
}

int main() {
	long long n, k;
	cin >> n >> k;
	vector<vector<vector<long long>>> dp(n + 1, vector<vector<long long>>(n+1, vector<long long>(2))); //     j
	vector<vector<vector<long long>>> dp1(n + 1, vector<vector<long long>>(n+1, vector<long long>(2))); //    j ( 1)
	dp[k][k] = { 1,1 };
	for (int i = 1; i < k; i++) dp1[k][i][1] = 1;
	for (int i = k + 1; i <= n; i++) dp1[k][i][0] = 1;
	for (int i = k + 1; i <= n; i++) {
		for (int j = i; j >= 1; --j) {
			dp[i][j][1] = dp1[i - j][j][0];
			dp[i][j][0] = dp1[i - j][j][1];
		}
		dp1[i][n][1] = 0;
		dp1[i][1][0] = 0;
		for (int j = 2; j <= n; j++) {
			dp1[i][j][0] = dp[i][j - 1][1] +dp[i][j-1][0]+ dp1[i][j - 1][0];
			dp1[i][j][0] %= mod;
		}
		for (int j = n-1; j >=1; --j) {
			dp1[i][j][1] = dp[i][j + 1][0] + dp[i][j + 1][1] + dp[i][j + 1][1];
			dp1[i][j][1] %= mod;
		}
	}
	long long ans = 0;
	for (int i = 0; i <= n; i++) {
		ans += dp[n][i][0];
		ans += dp[n][i][1];
		ans %= mod;
	}
	if (n == k) ans = 1;
	cout << ans;
	cin >> ans;
}
